;  disk.asm
;  Support for BIOS disk calls

    TITLE   DISK  -- LOW-LEVEL DISK ROUTINES
    NAME    DISK

;  Internal data 
X   EQU 6                       ;  for the large model programs

extrn DOS3CALL: far

.MODEL  LARGE
.DATA

    PUBLIC _DTAPTR              ; pointer to dta location

_DTAPTR     DW  0000H           ; DTA address for me
_DTADS      DW  0000H           ; DS for DTA

.CODE
    PUBLIC  _n_findfirst,_n_findnext,_makedir,_removedir

;**********************************************************************
;
;  find first
;   make dos find file names according to wildcards
;  n_findfirst(filename,attr)
;   char *filename; INT attr;
;
_n_findfirst    proc    far
    PUSH    BP
    MOV     BP,SP
    PUSH    ES
    PUSH    DS

    MOV     AH,02FH             ; DOS FUNCTION GET dta
    CALL   DOS3Call

;    INT     21H
    MOV     _DTAPTR,BX          ; SQUIRREL A COPY FOR ME
    MOV     AX,ES
    MOV     _DTADS,AX
    MOV     AX,[BP+X+2]         ; DS OF FILENAME PTR
    MOV     DS,AX
    MOV     DX,[BP+X]           ; PTR PART OF FILENAME
    MOV     CX,[BP+X+4]         ; ATTRIBUTE TO SEARCH FOR
    MOV     AH,04EH             ; FIND MATCHING FILE DOS CALL
    INT     21H
    JC      BADRET_FF              ; AX ALREADY CONTAINS ERROR CODE
    XOR     AX,AX

BADRET_FF:
    POP     DS
    POP     ES
    POP     BP
    RET
_n_findfirst    endp

;
;  n_findnext()
;  will find entries that follow findfirst
;  no need to respecify file name
;
_n_findnext proc    far

    MOV     AH,04FH             ; FIND NEXT DOS CALL
    INT     21H
    JC      BADRET_FN
    XOR     AX,AX
BADRET_FN:
    RET
_n_findnext endp

;**********************************************************************
;
;  makedir
;   make dos directory
;  makedir(filename)
;   char *filename;
;
_makedir  proc    far
    PUSH    BP
    MOV     BP,SP
    PUSH    ES
    PUSH    DS

    MOV     AX,[BP+X+2]         ; DS OF FILENAME PTR
    MOV     DS,AX
    MOV     DX,[BP+X]           ; PTR PART OF FILENAME
    MOV     AH,039H             ; CREATE DIRECTORY DOS CALL

    CALL   DOS3Call

    JC      BADRET_MD           ; AX ALREADY CONTAINS ERROR CODE
    XOR     AX,AX

BADRET_MD:
    POP     DS
    POP     ES
    POP     BP
    RET
_makedir endp


;**********************************************************************
;
;  removedir
;   remove dos directory
;  removedir(filename)
;   char *filename;
;
_removedir  proc    far
    PUSH    BP
    MOV     BP,SP
    PUSH    ES
    PUSH    DS

    MOV     AX,[BP+X+2]         ; DS OF FILENAME PTR
    MOV     DS,AX
    MOV     DX,[BP+X]           ; PTR PART OF FILENAME
    MOV     AH,03AH             ; REMOVE DIRECTORY DOS CALL

    CALL   DOS3Call

    JC      BADRET_RD           ; AX ALREADY CONTAINS ERROR CODE
    XOR     AX,AX

BADRET_RD:
    POP     DS
    POP     ES
    POP     BP
    RET
_removedir endp

end
